Main body

>module Main (compile, vcompile) where 

>import Maybe1
>import Types
>import Messages
>import Parse
>import IO
>import TypeCheck
>import Consistency
>import Compile
>import Indent
>import MD5

import IO
import Interpret
import SimplifyMain

Set the following flag to True to save files in /tmp, to avoid delays caused
by writing over the network

>saveToTmp = False
>version = "0.0.1"
>welcome = "CaspX version "++version++"\n"

>vcompile :: String -> IO()
>vcompile = compile0 True

>compile :: String -> IO()
>compile s = catch (compile0 False s) handler

>handler e = 
>  if isIllegalOperation e 
>  then putStr "I/O error (maybe file not found)\nGoodbye\n" 
>  else putStr ("Error: "++show e++"\nGoodbye\n")

data PDesc=PD [([([Char],[Char])],[Char],Player,Player,Msg,([Char],Bool))]

instance Show PDesc where
 show (PD []) = ""
 show (PD ((a,b,c,d,e,f):q)) = (show a)++"\n"++(show b)++"\n"++(show c)++"\n"++(show d)++"\n"++(show e)++"\n"++(show f)++"\n\n"++(show (PD q))

(AssignmentList, MsgNo, Player, Player, Msg, Test)

>compile0 :: Bool -> String -> IO()
>compile0 b filename = 
>  do putStr (welcome++"Parsing...\n")
>     fromHandle <- openFile (filename ++ ".spl") ReadMode 
>     contents   <- hGetContents fromHandle
>     compile1 b filename contents

>addAddr :: InputOLD -> InputOLD
>addAddr (fvts, fnts, fiks, dtdefs, procs, protdesc,[],[],[],[],notUsed,inlines,[],False,False,[],[],[],[],[],[],[],(False,False,False)) = (fvts, fnts, fiks, dtdefs, (addAddr2 procs), protdesc,[],[],[],[],notUsed,inlines,[],False,False,[],[],[],[],[],[],[],(False,False,False))

>addAddr2 [] = []
>addAddr2 ((a,b,c,d,e):q) = ((a,b,c,d++[Atom "addr"],e):(addAddr2 q))

>inputold::Input -> InputOLD
>inputold (fvts, fnts, fiks, dtdefs, procs, protdesc,inlines,external)=
> (fvts, fnts, fiks, dtdefs, procs, protdesc,[],[],[],[],notUsed,inlines,[],False,False,[],[],[],[],[],[],[],(False,False,False))

>compile1 :: Bool -> String -> String -> IO()
>compile1 b filename conts 
>  | isError parsed    
>      = putStr ("Parse errors:\n" ++ errorMsg parsed++"Goodbye\n")
>  | otherwise
>      = do  -- putStr ("FVTS:"++(show fvts)++"\nFNTS:"++(show fnts)++"\nFIKS:"++(show fiks)++"\nDTDEFS:"++(show dtdefs)++"\nPROCS:"++(show procs)++"\nINLINES:"++(show inlines)++"\nEXTERNAL:"++(show external)++"\nPROTDESC:"++(show (PD protdesc))++"\n")
>	     -- putStr (show channels++ "\n") 
>            -- putStr (show procs) :
>            -- putStr (concat (map showpd protdesc)) :
>            putStr "Parsing successful\nType checking...\n"
>            -- putStr "Type checking...\n" 
>            -- putStr (show crackables) 
>            compile2 b filename conts external (inputold (fvts, fnts, fiks, dtdefs, procs, protdesc,inlines,external))
>  where parsed = parse conts
>        (fvts, fnts, fiks, dtdefs, procs, protdesc,inlines,external)=body parsed
>	 --secrets, auths,
>	  --vts, iks, timestampinfo, 
>	  --, actualAgents, withdraw, 
>	  --stale, intruderId, intruderInitKnows, intruderProcs, 
>	  --crackables, deductions, guessables, equivs, channels) 

>showpd (_,n,a,b,m,_) = show n ++ show a ++ show b ++ show m ++ "\n"

>compile2 :: Bool -> String -> String -> ExternalList -> InputOLD -> IO()
>compile2 b filename conts external input =
>  if err /= "" then putStr (err++w++"\nGoodbye\n")
>  else do putStr w 
>	   putStr "Type checking successful\nConsistency checking...\n"
>          --putStr (dispIntermediare "" "" "" [] (addAddr input))
>	   compile3 b filename conts external (addAddr input)
>  where (err,w) = typecheck input

>compile3 :: Bool -> String -> String -> ExternalList -> InputOLD -> IO()
>compile3 b filename conts external input =
>  if err /= "" then putStr (err++w++"\nGoodbye\n")
>  else do (putStr w) 
>	   fileContent <- readFile (filename++".spl")
>	   hash <- return (md5 fileContent)
>	   (putStr "Consistency checking successful\nCompiling...\n")
>          (compile35 b filename conts external input (procsFromInputOLD input) hash)
>  where (err,w) = consistency input

>compile35 :: Bool -> String -> String -> ExternalList -> InputOLD -> ProcessList -> String -> IO()
>compile35 b filename conts external input [] hash = putStr ("All files written... Goodbye\n")
>compile35 b filename conts external input ((a1,a2,a3,a4,a5):q) hash = do
>			(compile4 b a2 (indent (makeOutput conts version a2 external input hash)) hash)
>			(compile35 b filename conts external input q hash)

>compile4 :: Bool -> String -> Output -> String -> IO()
>compile4 b filename output hash= 
>  let outfn = (if saveToTmp then "/tmp/" else "") ++ "java/protocols/" ++ filename ++ ".java"
>  in do putStr ("Writing file "++ outfn ++ (if b then "\n" ++ output else "\n")) 
>        toHandle <- openFile outfn WriteMode
>        hPutStr toHandle output
>        hClose toHandle

>procsFromInputOLD :: InputOLD -> ProcessList
>procsFromInputOLD (_,_,_,_,a,_,_,_,_,_,_,_,_,_,_,_,_,_,_,_,_,_,_) = a

==================== Simplifying transformations =======================

--vsimplify :: String -> IO()
--vsimplify = simplify0 True version

simplify :: String -> IO()
simplify = simplify0 False version
