package protocols;

import core.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.lang.reflect.Array;
import java.io.ObjectOutputStream;
import java.io.ByteArrayOutputStream;
import java.math.BigInteger;

public class INITDH extends Protocol {
   
   public INITDH (ObjectOutputStream oos) {
      super("core.Message" ,"core.MessageKey" ,"core.Nonce" );
      this.oos=oos;
      }
   
   public void run() {
      try {
         BigInteger g = null;
         BigInteger m = null;
         BigInteger x = null;
         BigInteger y = null;
         BigInteger gEx = null;
         BigInteger gEy = null;
         BigInteger k = null;
         
         g=freshBI();
         m=freshBI();
         x=freshBI();
         
         gEx=g.modPow(x,m);
         println("Building message m1");
         Message m1 =message();
         m1.addMessage(message(g.toString()));
         m1.addMessage(message(m.toString()));
         m1.addMessage(message(gEx.toString()));
         println("Sending message m1");
         put("B", m1.getString(),4000);
         
         println("waiting for m2");
         Message m2 = message(get("B"));
         gEy = new BigInteger(m2.getString());
         
         k=gEy.modPow(x,m);
         writeObject(k.toString());
         
         
         } catch (Exception e) {e.printStackTrace();System.exit(0);}
      }
   
   public static void subMain(String[] args,ObjectOutputStream oos) {
      INITDH A = new INITDH(oos);
      args=A.getArgs(args);
      A.start();
      }
   
   public String[] getArgs(String[] args) {
      try {
         if (args.length != 3) {
            args = (String[]) Array.newInstance("".getClass(), 3);
            BufferedReader in2 =
            new BufferedReader(new InputStreamReader(System.in));
            println("Type the DNS name of agent B [localhost]");
            args[0]=in2.readLine();
            if (args[0].compareTo("")==0) args[0]="localhost";
            println("Type the name of agent A [A]");
            args[1]=in2.readLine();
            if (args[1].compareTo("")==0) args[1]="A";
            println("Type the name of agent B [B]");
            args[2]=in2.readLine();
            if (args[2].compareTo("")==0) args[2]="B";
            }
         setIPToId(args[0],"B");
         setNameToId(args[1],"A");
         setNameToId(args[2],"B");
         } catch (Exception e) {e.printStackTrace();}
      return args;
      }
   
   public static void main(String[] args) {
      ObjectOutputStream oos=null;
      try {
         ByteArrayOutputStream os = new ByteArrayOutputStream();
         oos=new ObjectOutputStream(os);
         PrintOOS p=new PrintOOS("INITDH",oos,os);
         p.start();}
      catch (Exception e) {e.printStackTrace();}
      subMain(args,oos);
      }
   }