package protocols;

import core.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.lang.reflect.Array;
import java.io.ObjectOutputStream;
import java.io.ByteArrayOutputStream;
import java.math.BigInteger;

public class INITOR extends Protocol {
   
   public INITOR (ObjectOutputStream oos) {
      super("core.MessageT","core.MessageKeyT","core.NonceT");
      this.oos=oos;
      }
   
   public void run() {
      try {
         IMessageKey kab = null;
         
         println("creating nonce na");
         createNewNonce("na");
         println("creating nonce m");
         createNewNonce("m");
         
         println("Building message m1a");
         Message m1a =message();
         m1a.addMessage(message(agentFromId("a")));
         m1a.addMessage(message(agentFromId("b")));
         m1a.addMessage(message(nonceFromId("m")));
         println("Sending message m1a");
         put("b", m1a.getString(),4002);
         
         println("Building message m1b");
         Message m1b =message();
         m1b.addMessage(message(nonceFromId("na")));
         m1b.addMessage(message(nonceFromId("m")));
         m1b.addMessage(message(agentFromId("a")));
         m1b.addMessage(message(agentFromId("b")));
         println("Encrypting m1b");
         m1b.encrypt("DES", getSecretKey(nameFromId("a")));
         println("Sending message m1b");
         put("s", m1b.getString(),4000);
         
         println("waiting for m4");
         Message m4 = message(get("s"));
         checkTag(m4,"NKNK)");
         addParts(m4.getAllFields(),2);
         m0=getPart();
         setValueToNonce(m0.getString(),"m");
         m0=getPart();
         println("Decrypting m0");
         m0.decrypt("DES", getSecretKey(nameFromId("a")));
         checkTag(m0,"NK");
         addParts(m0.getAllFields(),2);
         m0=getPart();
         setValueToNonce(m0.getString(),"na");
         m0=getPart();
         kab= messageKey(m0);
         
         
         
         
         } catch (Exception e) {e.printStackTrace();System.exit(0);}
      }
   
   public static void subMain(String[] args,ObjectOutputStream oos) {
      INITOR a = new INITOR(oos);
      args=a.getArgs(args);
      a.start();
      }
   
   public String[] getArgs(String[] args) {
      try {
         if (args.length != 6) {
            args = (String[]) Array.newInstance("".getClass(), 6);
            BufferedReader in2 =
            new BufferedReader(new InputStreamReader(System.in));
            println("Type the SecretKeyStore file to use [secretkeystore]");
            args[0]=in2.readLine();
            if (args[0].compareTo("")==0) args[0]="secretkeystore";
            println("Type the DNS name of agent b [localhost]");
            args[1]=in2.readLine();
            if (args[1].compareTo("")==0) args[1]="localhost";
            println("Type the DNS name of agent s [localhost]");
            args[2]=in2.readLine();
            if (args[2].compareTo("")==0) args[2]="localhost";
            println("Type the name of agent a [a]");
            args[3]=in2.readLine();
            if (args[3].compareTo("")==0) args[3]="a";
            println("Type the name of agent b [b]");
            args[4]=in2.readLine();
            if (args[4].compareTo("")==0) args[4]="b";
            println("Type the name of agent s [s]");
            args[5]=in2.readLine();
            if (args[5].compareTo("")==0) args[5]="s";
            }
         setSKS(args[0]);
         setIPToId(args[1],"b");
         setIPToId(args[2],"s");
         setNameToId(args[3],"a");
         setNameToId(args[4],"b");
         setNameToId(args[5],"s");
         } catch (Exception e) {e.printStackTrace();}
      return args;
      }
   
   public static void main(String[] args) {
      ObjectOutputStream oos=null;
      try {
         ByteArrayOutputStream os = new ByteArrayOutputStream();
         oos=new ObjectOutputStream(os);
         PrintOOS p=new PrintOOS("INITOR",oos,os);
         p.start();}
      catch (Exception e) {e.printStackTrace();}
      subMain(args,oos);
      }
   }